<div class="flex tw-flex-col p-0" style="position: relative;">
    <ngx-spinner bdColor="rgba(0,0,0,0.8)" color="#fff" type="timer" size="large" [fullScreen]="false">
        <p style="color: white;margin-top: 30px;">Loading Datas...</p>
        <!--if fullscreen false  Your parent container(div) should have position: relative;  -->
    </ngx-spinner>

    <p-dataView #dv [value]="patientList" [paginator]="true" [rows]="9" filterBy="fname" [sortField]="sortField"
        [sortOrder]="sortOrder" layout="grid">
        <ng-template pTemplate="header">
            <div class="flex flex-column md:flex-row md:justify-content-between gap-2">
                <p-dropdown [options]="sortOptions" placeholder="เรียงตามชื่อ"
                    (onChange)="onSortChange($event)"></p-dropdown>

                <div class="flex flex-wrap tw-gap-x-2 md:justify-content-end md:align-items-end justify-content-start align-items-end">
                    <span class="p-input-icon-left p-input-icon-right">
                        <i class="pi pi-user" *ngIf="filterName == ''"></i>
                        <input type="text" pInputText placeholder="ค้นหา"
                        (input)="onFilter(dv, $event)" [(ngModel)]="filterName" />
                        <i class="pi pi-search"></i>
                        <button pButton pRipple type="button" icon="pi pi-times"
                            class="p-button-rounded p-button-text p-button-plain -ml-6 -mt-4"
                            (click)="clearFilter(dv,$event)" *ngIf="filterName !=''"></button>
                    </span>

                </div>

                <p-dataViewLayoutOptions></p-dataViewLayoutOptions>
            </div>
        </ng-template>

        <ng-template let-patientList let-i="rowIndex" pTemplate="listItem">
            <div class="flex tw-flex-col w-full p-2">
                <div class="tw-flex tw-flex-col tw-h-full">
                    <div
                        class="flex tw-w-full tw-h-full tw-bg-slate-50 tw-border tw-border-cyan-200 tw-rounded-2xl p-4 shadow">
                        <div class="flex-none tw-w-44 text-gray-600 bg-slate-100 tw-rounded-2xl"
                            *ngIf="!patientList.hideLeft"
                            [ngClass]="deviceType =='xs' || deviceType=='sm' ? 'hidden' : ''">
                            <div class="flex flex-row gap-x-4 content-center justify-center tw-h-fit tw-w-full">
                                <div class="flex items-center content-center justify-center ">
                                    <button
                                        class="tw-rounded-full bg-indigo-100  tw-border-indigo-600 tw-border-2 tw-w-16 tw-h-16 "
                                        (click)="navigatePatientInfo(patientList.admit_id)">
                                        <i class="fa-regular fa-address-book text-indigo-600 text-[28px]"></i>
                                    </button>
                                </div>
                                <div class="flex items-center content-center justify-center">
                                    <button
                                        class="tw-rounded-full bg-sky-100  tw-border-sky-600 tw-border-2 tw-w-16 tw-h-16 "
                                        (click)="navigateDoctorOrder(patientList.admit_id)">
                                        <i class="fa-solid fa-user-doctor text-sky-600 text-[28px]"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                        <div class="shrink tw-w-full tw-h-full">
                            <div class="flex tw-content-center tw-items-center tw-justify-center tw-h-fit">
                                <div class="flex-none hidden md:inline-flex lg:inline-flex xl:inline-flex xxl:inline-flex tw-w-35 tw-h-full p-0 tw-content-center"
                                    [ngClass]="deviceType =='xs' || deviceType=='sm' ? 'hidden' : ''">
                                    <button
                                        class=" tw-rounded-full p-3 tw-content-center tw-items-center tw-w-full tw-h-full"
                                        (click)="openPanelLeft(i)" *ngIf="patientList.hideLeft">
                                        <i
                                            class="fa-solid fa-chevron-right tw-align-middle text-4xl tw-w-10 tw-h-full text-indigo-400 hover:text-white "></i>
                                    </button>
                                    <button
                                        class="tw-bg-gradient-to-r tw-from-slate-300 tw-to-slate-100 tw-rounded-full p-3 tw-content-center tw-items-center tw-w-full tw-h-full"
                                        (click)="openPanelLeft2(i)" *ngIf="!patientList.hideLeft">
                                        <i
                                            class="fa-solid fa-chevron-left tw-align-middle text-4xl tw-w-10 tw-h-full text-indigo-400 hover:text-white "></i>
                                    </button>
                                </div>
                                <div class="shrink tw-w-full tw-h-fit pl-3 pr-3 pb-0 pt-0 example-boundary">
                                    <div class="flex tw-flex-col tw-h-full" cdkDragBoundary=".example-boundary" cdkDrag
                                        (cdkDragStarted)="onDragStarted($event,i)"
                                        (cdkDragEnded)="onDragEnded($event,i)">
                                        <div class="flex tw-h-full">
                                            <div class="flex-none">
                                                <div class="flex items-center">
                                                    <button
                                                        class="tw-rounded-full tw-border-2 p-2 bg-teal-500 tw-w-12 tw-h-12  tw-border-teal-500">
                                                        <i class="fa-solid fa-user text-white text-2xl "></i>
                                                    </button>
                                                </div>
                                            </div>
                                            <div class="grow tw-w-fit tw-h-full align-middle items-center">
                                                <div class="flex tw-flex-col tw-h-fit align-middle">
                                                    <div class="flex justify-between">
                                                        <div
                                                            class="flex flex-wrap tw-w-3/4 gap-x-3 pl-3 align-middle content-center tw-h-full">
                                                            <div
                                                                class="font-bold text-gray-600 align-middle content-center">
                                                                HN :</div>
                                                            <div> {{patientList.hn}}</div>
                                                            <div class="font-bold text-gray-600"> AN :</div>
                                                            <div> {{patientList.an}}</div>
                                                            <div class="font-bold text-gray-600"> ชื่อ-สกุล :</div>
                                                            <div> {{patientList.title}}{{patientList.fname}}
                                                                {{patientList.lname}}</div>
                                                            <div class="font-bold text-gray-600"> เพศ :</div>
                                                            <div> {{patientList.gender}}</div>
                                                            <div class="font-bold text-gray-600"> อายุ :</div>
                                                            <div> {{patientList.age | thaiage}}</div>
                                                        </div>
                                                        <div class="flex tw-w-1/4 justify-end">
                                                            <span
                                                                class="bg-green-200 p-1 text-md tw-w-fit tw-h-fit round font-bold">เตียง
                                                                : &nbsp;{{patientList.bed_number}}</span>
                                                        </div>
                                                    </div>

                                                    <div class="flex flex-wrap gap-x-3 pl-3 tw-h-full">
                                                        <div class="font-bold text-gray-600"> แพทย์ :</div>
                                                        <div> {{patientList.doctor_title}}{{patientList.doctor_fname}}
                                                            {{patientList.doctor_lname}}</div>
                                                        <div class="font-bold text-gray-600"> เบอร์โทร :</div>
                                                        <div> {{queryParamsData.phone}}</div>
                                                    </div>
                                                </div>

                                            </div>
                                        </div>
                                        <div class="flex flex-row content-center"
                                            *ngIf="deviceType =='xs' || deviceType=='sm'">
                                            <div class="flex justify-center tw-w-full gap-x-6">
                                                <button class="p-4  tw-w-10 tw-h-10"
                                                    (click)="navigatePatientInfo(patientList.an)">

                                                    <i
                                                        class="fa-regular fa-address-book text-indigo-600 text-[28px]"></i>

                                                </button>
                                                <button class="p-4  tw-w-10 tw-h-10"
                                                    (click)="navigateDoctorOrder(patientList.an)">
                                                    <i class="fa-solid fa-user-doctor text-sky-600 text-[28px]"></i>

                                                </button>
                                                <button class="p-4  tw-w-10 tw-h-10"
                                                    (click)="navigateAdmisstionNote(patientList.an)">
                                                    <i class="fa-solid fa-file-pen text-rose-600 text-[28px]"></i>

                                                </button>
                                                <button class="p-4  tw-w-10 tw-h-10"
                                                    (click)="navigateProgressNote(patientList.an)">
                                                    <i
                                                        class="fa-solid fa-clipboard-list text-yellotw-w-600 text-[28px]"></i>
                                                </button>
                                            </div>
                                        </div>
                                    </div>

                                </div>

                                <div class="flex-none hidden md:inline-flex lg:inline-flex xl:inline-flex xxl:inline-flex tw-w-35 tw-h-full p-0 tw-content-center"
                                    [ngClass]="deviceType =='xs' || deviceType=='sm' ? 'hidden' : ''">
                                    <button
                                        class="tw-bg-gradient-to-l tw-from-slate-100 tw-to-slate-300 tw-rounded-full p-3 tw-content-center tw-items-center tw-w-full tw-h-full"
                                        (click)="openPanelRight(i)" *ngIf="patientList.hideRight">
                                        <i
                                            class="fa-solid fa-chevron-left tw-align-middle text-4xl tw-w-10 tw-h-full text-indigo-400 hover:text-white "></i>
                                    </button>
                                    <button
                                        class="tw-bg-gradient-to-l tw-from-slate-100 tw-to-slate-300 tw-rounded-full p-3 tw-content-center tw-items-center tw-w-full tw-h-full"
                                        (click)="openPanelRight2(i)" *ngIf="!patientList.hideRight">
                                        <i
                                            class="fa-solid fa-chevron-right tw-align-middle text-4xl tw-w-10 tw-h-full text-indigo-400 hover:text-white "></i>
                                    </button>
                                </div>

                            </div>
                        </div>
                        <div class="flex-none tw-w-44 text-gray-600 bg-slate-100 tw-rounded-2xl"
                            *ngIf="!patientList.hideRight"
                            [ngClass]="deviceType =='xs' || deviceType=='sm' ? 'hidden' : ''">
                            <div class="flex flex-row gap-x-4 content-center justify-center tw-h-full tw-w-full">
                                <div class="flex items-center content-center justify-center ">
                                    <button
                                        class="tw-rounded-full bg-rose-100  tw-border-rose-600 tw-border-2 tw-w-16 tw-h-16 "
                                        (click)="navigateAdmisstionNote(patientList.admit_id)">
                                        <i class="fa-solid fa-file-pen text-rose-600 text-[28px]"></i>
                                    </button>
                                </div>
                                <div class="flex items-center content-center justify-center">
                                    <button
                                        class="tw-rounded-full bg-yellotw-w-100  tw-border-yellotw-w-600 tw-border-2 tw-w-16 tw-h-16 "
                                        (click)="navigateProgressNote(patientList.an)">
                                        <i class="fa-solid fa-clipboard-list text-yellotw-w-600 text-[28px]"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </ng-template>

        <ng-template let-patientList let-i="rowIndex" pTemplate="gridItem">
            <!-- <div class="col-12 md:col-4 lg:col-4 xl:col-3" (click)="navigateDoctorOrder(patientList.admit_id)"> -->
            <div class="col-12 md:col-6 lg:col-6 xl:col-3">
                <div
                    class="card m-3 border-1 surface-border cursor-pointer  hover:scale-110 duration-300 hover:-translate-y-1 ">

                    <div class="flex align-items-center justify-content-between mb-3">
                        <div class="flex  align-items-center mb-3">
                            <p-avatar *ngIf="patientList.gender =='ชาย'" size="xlarge" shape="circle"
                                styleClass="text-base bg-blue-100 text-blue-700">
                                <!-- <i  class="fa-solid fa-person text-4xl"></i> -->
                                <i  class="icon man-icon text-blue-700 text-4xl"></i>
                                </p-avatar>
                            <p-avatar *ngIf="patientList.gender =='หญิง'" size="xlarge" shape="circle"
                                styleClass="text-base bg-pink-100 text-pink-700">
                                <!-- <i class="fa-solid fa-person-dress text-4xl"></i> -->
                                <i class="icon woman-icon text-blue-700 text-4xl"></i>
                                </p-avatar>
                            <div class="flex flex-column ml-2">
                                <span class="text-xl"> {{patientList.title}}{{patientList.fname}}
                                    {{patientList.lname}}</span>
                                <div class="text-sm">
                                    อายุ: {{patientList.age | thaiage}}
                                </div>
                            </div>

                        </div>
                        <div class="flex align-items-center mb-3">
                            เพศ &nbsp;{{patientList.gender}}
                        </div>
                    </div>
                    <div class="flex align-items-center justify-content-between mb-3">
                        <!-- <span class="block font-bold text-6xl mb-3">{{wards.bed_amount}}</span> -->

                        <div class="col-8 flex p-2 surface-50 border-round-top">
                            <div class="p-2 flex-auto text-center md:text-left">
                                <span class="text-700 text-sm block">AN:</span>
                                <span class="text-900 font-medium text-xl block mt-2">{{patientList.an}}</span>
                            </div>
                            <p-divider align="center" layout="vertical"
                                styleClass="h-full  mx-0 lg:mx-3 surface-border"></p-divider>
                            <div class="p-2 flex-auto text-center md:text-left">
                                <span class="text-700 text-sm block">HN</span>
                                <span class="text-900 font-medium text-xl block mt-2">{{patientList.hn}}</span>
                            </div>

                        </div>

                        <div
                            class="flex align-items-center justify-content-end h-2rem px-2 py-4 bg-yellow-100 text-yellow-900 border-round">

                            <i class="fa-solid fa-bed text-xl mr-2"></i>
                            <span size="large" 
                                styleClass="text-base bg-yellow-200 text-yellow-700 text-xl">{{patientList.bed_number}}</span>
                        </div>
                    </div>
                    <div class="align-items-center justify-content-end h-2rem px-2 py-1  text-green-900 border-round hidden md:flex gap-x-4"
                        [ngStyle]="{'margin-top.px': 5}">
                        <p-avatar shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500 p-4"
                            (click)="navigateDoctorOrder(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-user-doctor text-xl"></i>
                        </p-avatar>
                        <p-avatar size="large" shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500"
                            (click)="navigatePatientInfo(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-circle-info text-3xl"></i>
                        </p-avatar>
                        <p-avatar size="large" shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500"
                            (click)="navigateAdmisstionNote(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-comment-medical text-3xl"></i>
                        </p-avatar>
                        <p-avatar size="large" shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500"
                            (click)="navigateEkg(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-heart-pulse text-3xl"></i>
                        </p-avatar>
                        <!-- Consult button -->
                        <p-avatar size="large" shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500"
                            (click)="navigateConsult(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-phone-volume text-3xl"></i>
                        </p-avatar>
                        <!-- lab -->
                        <p-avatar size="large" shape="circle" styleClass="text-base bg-cyan-100 text-cyan-500"
                            (click)="navigateLab(patientList.admit_id)" [ngStyle]="{'margin-right.px': 2}">
                            <i class="fa-solid fa-vial-virus text-3xl"></i>
                        </p-avatar>


                        <!-- <i class="fa-solid fa-user-doctor text-cyan-600"></i>
                        <span     class="text-sm ml-1">{{patientList.doctor_fname}}&nbsp;{{patientList.doctor_lname}}</span> -->
                    </div>
                    <div
                        class=" flex-wrap w-full     speeddial-mask-demo   block md:hidden">
                        <div class="flex ">

                            <p-speedDial class=" block md:hidden " [model]="speedDialItems"
                                type="semi-circle" [radius]="80" buttonClassName="p-button-outlined bg-cyan-100" showIcon="pi pi-bars" 
                                hideIcon="pi pi-times"
                                [ngStyle]="{'width.px': 10,'height.px': 10}"
                                (click)="toggles($event,patientList.admit_id)"></p-speedDial>
                                <!-- <p-speedDial class=" block md:hidden " [model]="speedDialItems" className="speeddial-left" direction="down" [transitionDelay]="50" showIcon="pi pi-bars" 
                                    hideIcon="pi pi-times" buttonClassName="p-button-outlined"></p-speedDial> -->


                        </div>
                    </div>

                </div>
            </div>

        </ng-template>

    </p-dataView>


</div>